/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const e="pager.info",r="pager.firstPage",t="pager.previousPage",o="pager.nextPage",l="pager.lastPage",a="pager.itemsPerPage",n="pager.pageSelection",i="pager.page",s="pager.of",u="pager.totalPages",p="pager.pageNumberLabel",c="pager.pageLabel",f="pager.ariaKeyshortcuts",O="pager.ariaLabel",g="pager.pageSizeAriaLabel",m="pager.mobileSelect",M="pager.moreButtonLabel",F="filter.eqOperator",L="filter.notEqOperator",b="filter.isNullOperator",I="filter.isNotNullOperator",A="filter.isEmptyOperator",E="filter.isNotEmptyOperator",d="filter.startsWithOperator",N="filter.containsOperator",P="filter.notContainsOperator",q="filter.endsWithOperator",h="filter.gteOperator",S="filter.gtOperator",x="filter.lteOperator",y="filter.ltOperator",G="filter.isTrue",B="filter.isFalse",C="filter.afterOrEqualOperator",w="filter.afterOperator",T="filter.beforeOperator",D="filter.beforeOrEqualOperator",W="filter.andLogic",v="filter.orLogic",z="filter.addExpression",K="filter.addGroup",R="filter.close",j="filter.groupAriaLabel",k="filter.expressionAriaLabel",H="filter.expressionDropdownAriaLabel",J="filter.expressionOperatorDropdownAriaLabel",Q="filter.enumFilterDropdownAriaLabel",U="filter.numericFilterAriaLabel",V="filter.textFilterAriaLabel",X="columnMenu.filterClearButton",Y="columnMenu.filterSubmitButton",Z="columnMenu.filterTitle",_="columnMenu.sortAscending",$="columnMenu.sortDescending",ee="columnMenu.filterEqOperator",re="columnMenu.filterNotEqOperator",te="columnMenu.filterIsNullOperator",oe="columnMenu.filterIsNotNullOperator",le="columnMenu.filterIsEmptyOperator",ae="columnMenu.filterIsNotEmptyOperator",ne="columnMenu.filterStartsWithOperator",ie="columnMenu.filterContainsOperator",se="columnMenu.filterNotContainsOperator",ue="columnMenu.filterEndsWithOperator",pe="columnMenu.filterGteOperator",ce="columnMenu.filterGtOperator",fe="columnMenu.filterLteOperator",Oe="columnMenu.filterLtOperator",ge="columnMenu.filterIsTrue",me="columnMenu.filterAfterOrEqualOperator",Me="columnMenu.filterAfterOperator",Fe="columnMenu.filterBeforeOperator",Le="columnMenu.filterBeforeOrEqualOperator",be="columnMenu.filterAndLogic",Ie="columnMenu.filterOrLogic",Ae="sort.ariaLabel",Ee="filter.ariaLabel",de={[a]:"items per page",[n]:"Select page",[e]:"{0} - {1} of {2} items",[r]:"Go to the first page",[t]:"Go to the previous page",[o]:"Go to the next page",[l]:"Go to the last page",[i]:"Page",[s]:"of",[u]:"{0}",[c]:"Page",[f]:"Enter ArrowRight ArrowLeft",[O]:"Pager",[g]:"Page size",[m]:"Select",[M]:"More pages",[p]:"Type a page number",[Ae]:"Sortable",[Ee]:"Filter",[F]:"Is equal to",[L]:"Is not equal to",[b]:"Is null",[I]:"Is not null",[A]:"Is empty",[E]:"Is not empty",[d]:"Starts with",[N]:"Contains",[P]:"Does not contain",[q]:"Ends with",[h]:"Is greater than or equal to",[S]:"Is greater than",[x]:"Is less than or equal to",[y]:"Is less than",[G]:"Is true",[B]:"Is false",[C]:"Is after or equal to",[w]:"Is after",[T]:"Is before",[D]:"Is before or equal to",[W]:"And",[v]:"Or",[z]:"Add Expression",[K]:"Add Group",[R]:"Remove",[j]:"Filter toolbar",[k]:"Filter expression row",[H]:"Filter dropdown",[J]:"Filter operator dropdown",[Q]:"Select True/False",[U]:"Enter number",[V]:"Enter text",[X]:"Clear",[Y]:"Filter",[Z]:"Filter",[_]:"Sort Ascending",[$]:"Sort Descending",[ee]:"Is equal to",[re]:"Is not equal to",[te]:"Is null",[oe]:"Is not null",[le]:"Is empty",[ae]:"Is not empty",[ne]:"Starts with",[ie]:"Contains",[se]:"Does not contain",[ue]:"Ends with",[pe]:"Is greater than or equal to",[ce]:"Is greater than",[fe]:"Is less than or equal to",[Oe]:"Is less than",[ge]:"Is true",[me]:"Is after or equal to",[Me]:"Is after",[Fe]:"Is before",[Le]:"Is before or equal to",[be]:"And",[Ie]:"Or"};exports.columnMenuFilterAfterOperator=Me;exports.columnMenuFilterAfterOrEqualOperator=me;exports.columnMenuFilterAndLogic=be;exports.columnMenuFilterBeforeOperator=Fe;exports.columnMenuFilterBeforeOrEqualOperator=Le;exports.columnMenuFilterClearButton=X;exports.columnMenuFilterContainsOperator=ie;exports.columnMenuFilterEndsWithOperator=ue;exports.columnMenuFilterEqOperator=ee;exports.columnMenuFilterGtOperator=ce;exports.columnMenuFilterGteOperator=pe;exports.columnMenuFilterIsEmptyOperator=le;exports.columnMenuFilterIsNotEmptyOperator=ae;exports.columnMenuFilterIsNotNullOperator=oe;exports.columnMenuFilterIsNullOperator=te;exports.columnMenuFilterIsTrue=ge;exports.columnMenuFilterLtOperator=Oe;exports.columnMenuFilterLteOperator=fe;exports.columnMenuFilterNotContainsOperator=se;exports.columnMenuFilterNotEqOperator=re;exports.columnMenuFilterOrLogic=Ie;exports.columnMenuFilterStartsWithOperator=ne;exports.columnMenuFilterSubmitButton=Y;exports.columnMenuFilterTitle=Z;exports.columnMenuSortAscending=_;exports.columnMenuSortDescending=$;exports.filterAddExpression=z;exports.filterAddGroup=K;exports.filterAfterOperator=w;exports.filterAfterOrEqualOperator=C;exports.filterAndLogic=W;exports.filterAriaLabel=Ee;exports.filterBeforeOperator=T;exports.filterBeforeOrEqualOperator=D;exports.filterClose=R;exports.filterContainsOperator=N;exports.filterEndsWithOperator=q;exports.filterEnumFilterDropdownAriaLabel=Q;exports.filterEqOperator=F;exports.filterExpressionAriaLabel=k;exports.filterExpressionDropdownAriaLabel=H;exports.filterExpressionOperatorDropdownAriaLabel=J;exports.filterGroupAriaLabel=j;exports.filterGtOperator=S;exports.filterGteOperator=h;exports.filterIsEmptyOperator=A;exports.filterIsFalse=B;exports.filterIsNotEmptyOperator=E;exports.filterIsNotNullOperator=I;exports.filterIsNullOperator=b;exports.filterIsTrue=G;exports.filterLtOperator=y;exports.filterLteOperator=x;exports.filterNotContainsOperator=P;exports.filterNotEqOperator=L;exports.filterNumericFilterAriaLabel=U;exports.filterOrLogic=v;exports.filterStartsWithOperator=d;exports.filterTextFilterAriaLabel=V;exports.messages=de;exports.pagerAriaKeyshortcuts=f;exports.pagerAriaLabel=O;exports.pagerFirstPage=r;exports.pagerInfo=e;exports.pagerItemPerPage=a;exports.pagerLastPage=l;exports.pagerMobileSelect=m;exports.pagerMoreButtonLabel=M;exports.pagerNextPage=o;exports.pagerOf=s;exports.pagerPage=i;exports.pagerPageLabel=c;exports.pagerPageNumberLabel=p;exports.pagerPageSelection=n;exports.pagerPageSizeAriaLabel=g;exports.pagerPreviousPage=t;exports.pagerTotalPages=u;exports.sortAriaLabel=Ae;
